#ifndef CHIP_PINS_H
#define CHIP_PINS_H

#include "chip_pin_defs_v1.h"
#include "init/chip_cfg_defs.h"
#include "init/chip_ioremap_defs.h"
#include "chip_devtype_spec_features.h"


#define CHIP_PORT_A 0
#define CHIP_PORT_B 1
#define CHIP_PORT_C 2
#define CHIP_PORT_D 3
#define CHIP_PORT_E 4
#define CHIP_PORT_F 5
#define CHIP_PORT_G 6



/* ------------------------ Функции пинов ------------------------------------*/

/********************************** Порт A ************************************/
/*----- Пин PA0  ------------------------------------------------------------ */
#define CHIP_PIN_PA0_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 0)
#define CHIP_PIN_PA0_ADC_IN0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 0)    /* std */
#define CHIP_PIN_PA0_OPA_P4             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 0)
#define CHIP_PIN_PA0_WKUP1              CHIP_PIN_ID_IN      (CHIP_PORT_A, 0, CHIP_PER_ID_WKUP)  /* std */
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_3) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_1_B10_11)
#define CHIP_PIN_PA0_TIM2_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 0, CHIP_PER_ID_TIM2)  /* std */
#define CHIP_PIN_PA0_TIM2_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 0, CHIP_PER_ID_TIM2)  /* std */
#define CHIP_PIN_PA0_TIM2_ETR           CHIP_PIN_ID_IN      (CHIP_PORT_A, 0, CHIP_PER_ID_TIM2)  /* std */
#endif
#define CHIP_PIN_PA0_USART2_CTS         CHIP_PIN_ID_IN      (CHIP_PORT_A, 0, CHIP_PER_ID_USART2) /* std */


/*----- Пин PA1  ------------------------------------------------------------ */
#define CHIP_PIN_PA1_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 1)
#define CHIP_PIN_PA1_ADC_IN1            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 1)    /* std */
#define CHIP_PIN_PA1_OPA_N4             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 1)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PA1_TIM1_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 1, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PA1_TIM1_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 1, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PA1_TIM1_CH2N          CHIP_PIN_ID_AF      (CHIP_PORT_A, 1, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_3) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_1_B10_11)
#define CHIP_PIN_PA1_TIM2_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 1, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA1_TIM2_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 1, CHIP_PER_ID_TIM2)
#endif
#define CHIP_PIN_PA1_USART2_RTS         CHIP_PIN_ID_AF      (CHIP_PORT_A, 1, CHIP_PER_ID_USART2)


/*----- Пин PA2  ------------------------------------------------------------ */
#define CHIP_PIN_PA2_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 2)
#define CHIP_PIN_PA2_ADC_IN2            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 2)    /* std */
#define CHIP_PIN_PA2_OPA_O2             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 2)
#define CHIP_PIN_PA2_CMP1_P0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 2)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9)
#define CHIP_PIN_PA2_TIM1_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 2, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PA2_TIM1_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 2, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A3_A2_B12_A6) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_A2_B12_A6)
#define CHIP_PIN_PA2_TIM2_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 2, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA2_TIM2_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 2, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_3) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_A2_3)
#define CHIP_PIN_PA2_TIM2_CH3_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 2, CHIP_PER_ID_TIM2)    /* std */
#define CHIP_PIN_PA2_TIM2_CH3_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 2, CHIP_PER_ID_TIM2)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A4_A5_A3_A2_A13)
#define CHIP_PIN_PA2_USART1_CTS         CHIP_PIN_ID_IN      (CHIP_PORT_A, 2, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART2 || (CHIP_IOREMAP_USART2 == CHIP_IOREMAP_USART2_A2_4_A0_1)
#define CHIP_PIN_PA2_USART2_TX          CHIP_PIN_ID_AF      (CHIP_PORT_A, 2, CHIP_PER_ID_USART2) /* std */
#endif


/*----- Пин PA3  ------------------------------------------------------------ */
#define CHIP_PIN_PA3_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 3)
#define CHIP_PIN_PA3_ADC_IN3            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 3)    /* std */
#define CHIP_PIN_PA3_OPA_O0             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 3)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PA3_TIM1_ETR           CHIP_PIN_ID_IN      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PA3_TIM1_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PA3_TIM1_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_3) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_A2_3)
#define CHIP_PIN_PA3_TIM2_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM2)    /* std */
#define CHIP_PIN_PA3_TIM2_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM2)    /* std */
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A3_A2_B12_A6)
#define CHIP_PIN_PA3_TIM2_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA3_TIM2_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA3_TIM2_ETR           CHIP_PIN_ID_IN      (CHIP_PORT_A, 3, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A4_A5_A3_A2_A13)
#define CHIP_PIN_PA3_USART1_CK          CHIP_PIN_ID_AF      (CHIP_PORT_A, 3, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART2 || (CHIP_IOREMAP_USART2 == CHIP_IOREMAP_USART2_A2_4_A0_1)
#define CHIP_PIN_PA3_USART2_RX          CHIP_PIN_ID_IN      (CHIP_PORT_A, 3, CHIP_PER_ID_USART2)  /* std */
#endif


/*----- Пин PA4  ------------------------------------------------------------ */
#define CHIP_PIN_PA4_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 4)
#define CHIP_PIN_PA4_ADC_IN4            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 4)    /* std */
#define CHIP_PIN_PA4_OPA_O3             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 4)
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_B8_A5_A4)
#define CHIP_PIN_PA4_TIM2_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 4, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA4_TIM2_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 4, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A4_A5_A3_A2_A13)
#define CHIP_PIN_PA4_USART1_TX          CHIP_PIN_ID_AF      (CHIP_PORT_A, 4, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A5_A4_A6_B7_8)
#define CHIP_PIN_PA4_USART1_RX          CHIP_PIN_ID_IN      (CHIP_PORT_A, 4, CHIP_PER_ID_USART1)
#endif
#define CHIP_PIN_PA4_USART2_CK          CHIP_PIN_ID_AF      (CHIP_PORT_A, 4, CHIP_PER_ID_USART2)  /* std */
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A4_7)
#define CHIP_PIN_PA4_SPI1_NSS_MST       CHIP_PIN_ID_AF      (CHIP_PORT_A, 4, CHIP_PER_ID_SPI1)    /* std */
#define CHIP_PIN_PA4_SPI1_NSS_SLV       CHIP_PIN_ID_IN      (CHIP_PORT_A, 4, CHIP_PER_ID_SPI1)    /* std */
#endif


/*----- Пин PA5  ------------------------------------------------------------ */
#define CHIP_PIN_PA5_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 5)
#define CHIP_PIN_PA5_ADC_IN5            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 5)    /* std */
#define CHIP_PIN_PA5_OPA_N3             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 5)
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_B8_A5_A4)
#define CHIP_PIN_PA5_TIM2_CH3_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 5, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA5_TIM2_CH3_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 5, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A5_A4_A6_B7_8)
#define CHIP_PIN_PA5_USART1_TX          CHIP_PIN_ID_AF      (CHIP_PORT_A, 5, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A4_A5_A3_A2_A13)
#define CHIP_PIN_PA5_USART1_RX          CHIP_PIN_ID_IN      (CHIP_PORT_A, 5, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_A5_B5_A6_7_A15)
#define CHIP_PIN_PA5_USART4_TX          CHIP_PIN_ID_AF      (CHIP_PORT_A, 5, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A4_7)
#define CHIP_PIN_PA5_SPI1_SCK_MST       CHIP_PIN_ID_AF      (CHIP_PORT_A, 5, CHIP_PER_ID_SPI1)    /* std */
#define CHIP_PIN_PA5_SPI1_SCK_SLV       CHIP_PIN_ID_IN      (CHIP_PORT_A, 5, CHIP_PER_ID_SPI1)    /* std */
#endif


/*----- Пин PA6  ------------------------------------------------------------ */
#define CHIP_PIN_PA6_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 6)
#define CHIP_PIN_PA6_ADC_IN6            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 6)    /* std */
#define CHIP_PIN_PA6_OPA_N1             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 6)
#define CHIP_PIN_PA6_OPA_P5             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 6)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA6_TIM1_BKIN          CHIP_PIN_ID_IN      (CHIP_PORT_A, 6)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A3_A2_B12_A6) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_A2_B12_A6)
#define CHIP_PIN_PA6_TIM2_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 6, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA6_TIM2_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 6, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_TIM3 || (CHIP_IOREMAP_TIM3 == CHIP_IOREMAP_TIM3_A6_7_B0_1)
#define CHIP_PIN_PA6_TIM3_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 6, CHIP_PER_ID_TIM3)    /* std */
#define CHIP_PIN_PA6_TIM3_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 6, CHIP_PER_ID_TIM3)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A5_A4_A6_B7_8) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B11_B9_A6_A14_A13)
#define CHIP_PIN_PA6_USART1_CK          CHIP_PIN_ID_AF      (CHIP_PORT_A, 6, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_A5_B5_A6_7_A15)
#define CHIP_PIN_PA6_USART4_CK          CHIP_PIN_ID_AF      (CHIP_PORT_A, 6, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A4_7)
#define CHIP_PIN_PA6_SPI1_MISO_MST      CHIP_PIN_ID_IN      (CHIP_PORT_A, 6, CHIP_PER_ID_SPI1)    /* std */
#define CHIP_PIN_PA6_SPI1_MISO_SLV      CHIP_PIN_ID_AF      (CHIP_PORT_A, 6, CHIP_PER_ID_SPI1)    /* std */
#endif


/*----- Пин PA7  ------------------------------------------------------------ */
#define CHIP_PIN_PA7_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 7)
#define CHIP_PIN_PA7_ADC_IN7            CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 7)    /* std */
#define CHIP_PIN_PA7_OPA_N5             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 7)
#define CHIP_PIN_PA7_OPA_P3             CHIP_PIN_ID_ANALOG  (CHIP_PORT_A, 7)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PA7_TIM1_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 7, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PA7_TIM1_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 7, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA7_TIM1_CH1N          CHIP_PIN_ID_AF      (CHIP_PORT_A, 7, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM3 || (CHIP_IOREMAP_TIM3 == CHIP_IOREMAP_TIM3_A6_7_B0_1)
#define CHIP_PIN_PA7_TIM3_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 7, CHIP_PER_ID_TIM3)    /* std */
#define CHIP_PIN_PA7_TIM3_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 7, CHIP_PER_ID_TIM3)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_A5_B5_A6_7_A15)
#define CHIP_PIN_PA7_USART4_CTS         CHIP_PIN_ID_IN      (CHIP_PORT_A, 7, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A4_7)
#define CHIP_PIN_PA7_SPI1_MOSI_MST      CHIP_PIN_ID_AF      (CHIP_PORT_A, 7, CHIP_PER_ID_SPI1)    /* std */
#define CHIP_PIN_PA7_SPI1_MOSI_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_A, 7, CHIP_PER_ID_SPI1)    /* std */
#endif


/*----- Пин PA8  ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PA8_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 8)
#define CHIP_PIN_PA8_MCO                CHIP_PIN_ID_AF      (CHIP_PORT_A, 8, CHIP_PER_ID_CLKOUT)  /* std */
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA8_TIM1_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 8, CHIP_PER_ID_TIM1)    /* std */
#define CHIP_PIN_PA8_TIM1_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 8, CHIP_PER_ID_TIM1)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A9_10_A8_A11_12) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B6_7_A8_A11_12)
#define CHIP_PIN_PA8_USART1_CK          CHIP_PIN_ID_AF      (CHIP_PORT_A, 8, CHIP_PER_ID_USART1)  /* std */
#endif
#endif


/*----- Пин PA9  ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PA9_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 9)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA9_TIM1_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_A, 9, CHIP_PER_ID_TIM1)    /* std */
#define CHIP_PIN_PA9_TIM1_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_A, 9, CHIP_PER_ID_TIM1)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A9_10_A8_A11_12)
#define CHIP_PIN_PA9_USART1_TX          CHIP_PIN_ID_AF      (CHIP_PORT_A, 9, CHIP_PER_ID_USART1)  /* std */
#endif
#endif


/*----- Пин PA10 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PA10_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 10)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA10_TIM1_CH3_IN       CHIP_PIN_ID_IN      (CHIP_PORT_A, 10, CHIP_PER_ID_TIM1)   /* std */
#define CHIP_PIN_PA10_TIM1_CH3_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_A, 10, CHIP_PER_ID_TIM1)   /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A9_10_A8_A11_12)
#define CHIP_PIN_PA10_USART1_RX         CHIP_PIN_ID_IN      (CHIP_PORT_A, 10, CHIP_PER_ID_USART1) /* std */
#endif
#endif


/*----- Пин PA11 ------------------------------------------------------------ */
#define CHIP_PIN_PA11_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 11)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA11_TIM1_CH4_IN       CHIP_PIN_ID_IN      (CHIP_PORT_A, 11, CHIP_PER_ID_TIM1)   /* std */
#define CHIP_PIN_PA11_TIM1_CH4_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_A, 11, CHIP_PER_ID_TIM1)   /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A9_10_A8_A11_12) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B6_7_A8_A11_12)
#define CHIP_PIN_PA11_USART1_CTS        CHIP_PIN_ID_IN      (CHIP_PORT_A, 11, CHIP_PER_ID_USART1) /* std */
#endif
#if !defined CHIP_IOREMAP_USART2 || (CHIP_IOREMAP_USART2 == CHIP_IOREMAP_USART2_A11_12_4_0_1)
#define CHIP_PIN_PA11_USART2_TX         CHIP_PIN_ID_AF      (CHIP_PORT_A, 11, CHIP_PER_ID_USART2)
#endif
#if !defined CHIP_IOREMAP_USART2 || (CHIP_IOREMAP_USART2 == CHIP_IOREMAP_USART2_A12_11_4_0_1)
#define CHIP_PIN_PA11_USART2_RX         CHIP_PIN_ID_IN      (CHIP_PORT_A, 11, CHIP_PER_ID_USART2)
#endif
#if !defined CHIP_IOREMAP_CAN1 || (CHIP_IOREMAP_CAN1 == CHIP_IOREMAP_CAN1_A11_12)
#define CHIP_PIN_PA11_CAN1_RX           CHIP_PIN_ID_IN      (CHIP_PORT_A, 11, CHIP_PER_ID_CAN1)   /* std */
#endif
#define CHIP_PIN_PA11_USB1_DM           CHIP_PIN_ID_FORCED  (CHIP_PORT_A, 11, CHIP_PER_ID_USBFS)  /* std */


/*----- Пин PA12 ------------------------------------------------------------ */
#define CHIP_PIN_PA12_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 12)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PA12_TIM1_BKIN         CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PA12_TIM1_ETR          CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_TIM1)   /* std */
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_A2_B12_A6) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_B8_A5_A4)
#define CHIP_PIN_PA12_TIM2_CH1_IN       CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA12_TIM2_CH1_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_A, 12, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PA12_TIM2_ETR          CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B12_A12_B6_8)
#define CHIP_PIN_PA12_USART1_RX         CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A9_10_A8_A11_12) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B6_7_A8_A11_12)
#define CHIP_PIN_PA12_USART1_RTS        CHIP_PIN_ID_AF      (CHIP_PORT_A, 12, CHIP_PER_ID_USART1) /* std */
#endif
#if !defined CHIP_IOREMAP_USART2 || (CHIP_IOREMAP_USART2 == CHIP_IOREMAP_USART2_A12_11_4_0_1)
#define CHIP_PIN_PA12_USART2_TX         CHIP_PIN_ID_AF      (CHIP_PORT_A, 12, CHIP_PER_ID_USART2)
#endif
#if !defined CHIP_IOREMAP_USART2 || (CHIP_IOREMAP_USART2 == CHIP_IOREMAP_USART2_A11_12_4_0_1)
#define CHIP_PIN_PA12_USART2_RX         CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_USART2)
#endif
#if !defined CHIP_IOREMAP_I2C1 || (CHIP_IOREMAP_I2C1 == CHIP_IOREMAP_I2C1_A13_A12)
#define CHIP_PIN_PA12_I2C1_SDA          CHIP_PIN_ID_AF_OD   (CHIP_PORT_A, 12, CHIP_PER_ID_I2C1)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A12_B6_B8_B7)
#define CHIP_PIN_PA12_SPI1_NSS_MST      CHIP_PIN_ID_AF      (CHIP_PORT_A, 12, CHIP_PER_ID_SPI1)
#define CHIP_PIN_PA12_SPI1_NSS_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_A, 12, CHIP_PER_ID_SPI1)
#endif
#if !defined CHIP_IOREMAP_CAN1 || (CHIP_IOREMAP_CAN1 == CHIP_IOREMAP_CAN1_A11_12)
#define CHIP_PIN_PA12_CAN1_TX           CHIP_PIN_ID_AF      (CHIP_PORT_A, 12, CHIP_PER_ID_CAN1)  /* std */
#endif
#define CHIP_PIN_PA12_USB1_DP           CHIP_PIN_ID_FORCED  (CHIP_PORT_A, 12, CHIP_PER_ID_USBFS) /* std */


/*----- Пин PA13 (SWDIO) ---------------------------------------------------- */
#if !defined CHIP_IOREMAP_SDI_EN || !CHIP_IOREMAP_SDI_EN
#define CHIP_PIN_PA13_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 13)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PA13_TIM1_ETR          CHIP_PIN_ID_IN      (CHIP_PORT_A, 13, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PA13_TIM1_BKIN         CHIP_PIN_ID_IN      (CHIP_PORT_A, 13, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A4_A5_A3_A2_A13) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B11_B9_A6_A14_A13)
#define CHIP_PIN_PA13_USART1_RTS        CHIP_PIN_ID_AF      (CHIP_PORT_A, 13, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_I2C1 || (CHIP_IOREMAP_I2C1 == CHIP_IOREMAP_I2C1_A13_A12)
#define CHIP_PIN_PA13_I2C1_SCL          CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 13, CHIP_PER_ID_I2C1)
#endif
#endif


/*----- Пин PA14 (SWCLK) ---------------------------------------------------- */
#if !defined CHIP_IOREMAP_SDI_EN || !CHIP_IOREMAP_SDI_EN
#define CHIP_PIN_PA14_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 14)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PA14_TIM1_CH3_IN       CHIP_PIN_ID_IN      (CHIP_PORT_A, 14, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PA14_TIM1_CH3_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_A, 14, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PA14_TIM1_CH1N         CHIP_PIN_ID_AF      (CHIP_PORT_A, 14, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B11_B9_A6_A14_A13)
#define CHIP_PIN_PA14_USART1_CTS        CHIP_PIN_ID_IN      (CHIP_PORT_A, 14, CHIP_PER_ID_USART1)
#endif
#endif


/*----- Пин PA15 ------------------------------------------------------------ */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32
#define CHIP_PIN_PA15_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_A, 15)
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_A2_3) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_B10_11)
#define CHIP_PIN_PA15_TIM2_CH1_IN       CHIP_PIN_ID_IN      (CHIP_PORT_A, 15, CHIP_PER_ID_TIM2)  /* std */
#define CHIP_PIN_PA15_TIM2_CH1_OUT      CHIP_PIN_ID_IN      (CHIP_PORT_A, 15, CHIP_PER_ID_TIM2)  /* std */
#define CHIP_PIN_PA15_TIM2_ETR          CHIP_PIN_ID_IN      (CHIP_PORT_A, 15, CHIP_PER_ID_TIM2)  /* std */
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_A5_B5_A6_7_A15)
#define CHIP_PIN_PA15_USART4_RTS        CHIP_PIN_ID_AF      (CHIP_PORT_A, 15, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A15_B3_5)
#define CHIP_PIN_PA15_SPI1_NSS_MST      CHIP_PIN_ID_AF      (CHIP_PORT_A, 15, CHIP_PER_ID_SPI1)  /* std */
#define CHIP_PIN_PA15_SPI1_NSS_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_A, 15, CHIP_PER_ID_SPI1)  /* std */
#endif
#endif


/*********************************** Порт B ***********************************/
/*----- Пин PB0  ------------------------------------------------------------ */
#define CHIP_PIN_PB0_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 0)
#define CHIP_PIN_PB0_ADC_IN8            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 0)  /* std */
#define CHIP_PIN_PB0_OPA_P1             CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 0)
#define CHIP_PIN_PB0_OPA_O4             CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 0)
#define CHIP_PIN_PB0_CMP1_OUT0          CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 0)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PB0_TIM1_CH2N          CHIP_PIN_ID_AF      (CHIP_PORT_B, 0, CHIP_PER_ID_TIM1)
#endif
#define CHIP_PIN_PB0_TIM3_CH3_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 0, CHIP_PER_ID_TIM3)  /* std */
#define CHIP_PIN_PB0_TIM3_CH3_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 0, CHIP_PER_ID_TIM3)  /* std */
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_B0_4)
#define CHIP_PIN_PB0_USART4_TX          CHIP_PIN_ID_AF      (CHIP_PORT_B, 0, CHIP_PER_ID_USART4)
#endif


/*----- Пин PB1  ------------------------------------------------------------ */
#define CHIP_PIN_PB1_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 1)
#define CHIP_PIN_PB1_ADC_IN9            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 1)    /* std */
#define CHIP_PIN_PB1_OPA_O1             CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 1)
#define CHIP_PIN_PB1_CMP1_N0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 1)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PB1_TIM1_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PB1_TIM1_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PB1_TIM1_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PB1_TIM1_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9)
#define CHIP_PIN_PB1_TIM1_CH2N          CHIP_PIN_ID_AF      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_A6_7_B0_1)
#define CHIP_PIN_PB1_TIM1_CH3N          CHIP_PIN_ID_AF      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM1)
#endif
#define CHIP_PIN_PB1_TIM3_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM3)  /* std */
#define CHIP_PIN_PB1_TIM3_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 1, CHIP_PER_ID_TIM3)  /* std */
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_B0_4)
#define CHIP_PIN_PB1_USART4_RX          CHIP_PIN_ID_IN      (CHIP_PORT_B, 1, CHIP_PER_ID_USART4)
#endif


/*----- Пин PB2 (BOOT1) ----------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32
#define CHIP_PIN_PB2_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 2)
#define CHIP_PIN_PB2_CMP1_P1            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 2)
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_B0_4)
#define CHIP_PIN_PB2_USART4_CK          CHIP_PIN_ID_AF      (CHIP_PORT_B, 2, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B5_B7_B6_B2)
#define CHIP_PIN_PB2_LPTIM1_OUT         CHIP_PIN_ID_AF      (CHIP_PORT_B, 2, CHIP_PER_ID_LPTIM1)
#endif
#endif


/*----- Пин PB3 ------------------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 28
#define CHIP_PIN_PB3_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 3)
#define CHIP_PIN_PB3_CMP1_N1            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 3)
#define CHIP_PIN_PB3_CMP2_N0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 3)
#define CHIP_PIN_PB3_CMP3_N0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 3)
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_A2_3) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_B10_11)
#define CHIP_PIN_PB3_TIM2_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 3, CHIP_PER_ID_TIM2)  /* std */
#define CHIP_PIN_PB3_TIM2_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 3, CHIP_PER_ID_TIM2)  /* std */
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_B0_4)
#define CHIP_PIN_PB3_USART4_CTS         CHIP_PIN_ID_IN      (CHIP_PORT_B, 3, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A15_B3_5)
#define CHIP_PIN_PB3_SPI1_SCK_MST       CHIP_PIN_ID_AF      (CHIP_PORT_B, 3, CHIP_PER_ID_SPI1)  /* std */
#define CHIP_PIN_PB3_SPI1_SCK_SLV       CHIP_PIN_ID_IN      (CHIP_PORT_B, 3, CHIP_PER_ID_SPI1)  /* std */
#endif
#endif


/*----- Пин PB4 ------------------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32
#define CHIP_PIN_PB4_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 4)
#define CHIP_PIN_PB4_CMP3_OUT0          CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 4)
#if !defined CHIP_IOREMAP_TIM3 || (CHIP_IOREMAP_TIM3 == CHIP_IOREMAP_TIM3_B4_5_B0_1)
#define CHIP_PIN_PB4_TIM3_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 4, CHIP_PER_ID_TIM3)  /* std */
#define CHIP_PIN_PB4_TIM3_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 4, CHIP_PER_ID_TIM3)  /* std */
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_B0_4)
#define CHIP_PIN_PB3_USART4_RTS         CHIP_PIN_ID_AF      (CHIP_PORT_B, 4, CHIP_PER_ID_USART4)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A15_B3_5)
#define CHIP_PIN_PB4_SPI1_MISO_MST      CHIP_PIN_ID_IN      (CHIP_PORT_B, 4, CHIP_PER_ID_SPI1)  /* std */
#define CHIP_PIN_PB4_SPI1_MISO_SLV      CHIP_PIN_ID_AF      (CHIP_PORT_B, 4, CHIP_PER_ID_SPI1)  /* std */
#endif
#endif


/*----- Пин PB5  ------------------------------------------------------------ */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 28
#define CHIP_PIN_PB5_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 5)
#define CHIP_PIN_PB5_CMP2_OUT0          CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 5)
#define CHIP_PIN_PB5_CMP3_P0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 5)
#if !defined CHIP_IOREMAP_TIM3 || (CHIP_IOREMAP_TIM3 == CHIP_IOREMAP_TIM3_B4_5_B0_1)
#define CHIP_PIN_PB5_TIM3_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 5, CHIP_PER_ID_TIM3)  /* std */
#define CHIP_PIN_PB5_TIM3_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 5, CHIP_PER_ID_TIM3)  /* std */
#endif
#if !defined CHIP_IOREMAP_USART4 || (CHIP_IOREMAP_USART4 == CHIP_IOREMAP_USART4_A5_B5_A6_7_A15)
#define CHIP_PIN_PB5_USART4_RX          CHIP_PIN_ID_IN      (CHIP_PORT_B, 5, CHIP_PER_ID_USART4)
#endif
#define CHIP_PIN_PB5_I2C1_SMBA          CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 5, CHIP_PER_ID_I2C1)  /* std */
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A15_B3_5)
#define CHIP_PIN_PB5_SPI1_MOSI_MST      CHIP_PIN_ID_AF      (CHIP_PORT_B, 5, CHIP_PER_ID_SPI1)  /* std */
#define CHIP_PIN_PB5_SPI1_MOSI_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_B, 5, CHIP_PER_ID_SPI1)  /* std */
#endif
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B5_B7_B6_B2)
#define CHIP_PIN_PB5_LPTIM1_IN1         CHIP_PIN_ID_IN      (CHIP_PORT_B, 5, CHIP_PER_ID_LPTIM1)
#endif
#endif


/*----- Пин PB6  ------------------------------------------------------------ */
#define CHIP_PIN_PB6_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 6)
#define CHIP_PIN_PB6_CMP2_P1            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 6)
#define CHIP_PIN_PB6_USBPD_CC1_SNK      CHIP_PIN_ID_IN_EX   (CHIP_PORT_B, 6, CHIP_PER_ID_USBPD, CHIP_PIN_CFG_OSPEED_50MHZ | CHIP_PIN_CFG_NOPULL)
#define CHIP_PIN_PB6_USBPD_CC1_SRC      CHIP_PIN_ID_IN_EX   (CHIP_PORT_B, 6, CHIP_PER_ID_USBPD, CHIP_PIN_CFG_OSPEED_50MHZ | CHIP_PIN_CFG_PULLUP)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9)
#define CHIP_PIN_PB6_TIM1_ETR           CHIP_PIN_ID_IN      (CHIP_PORT_B, 6, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PB6_TIM1_CH3_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 6, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PB6_TIM1_CH3_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 6, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM4 || (CHIP_IOREMAP_TIM4 == CHIP_IOREMAP_TIM4_B6_9)
#define CHIP_PIN_PB6_TIM4_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 6, CHIP_PER_ID_TIM4)    /* std */
#define CHIP_PIN_PB6_TIM4_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 6, CHIP_PER_ID_TIM4)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B6_7_A8_A11_12)
#define CHIP_PIN_PB6_USART1_TX          CHIP_PIN_ID_AF      (CHIP_PORT_B, 6, CHIP_PER_ID_USART1)  /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B12_A12_B6_8)
#define CHIP_PIN_PB6_USART1_CK          CHIP_PIN_ID_AF      (CHIP_PORT_B, 6, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_I2C1 || (CHIP_IOREMAP_I2C1 == CHIP_IOREMAP_I2C1_B6_7)
#define CHIP_PIN_PB6_I2C1_SCL           CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 6, CHIP_PER_ID_I2C1)    /* std */
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A12_B6_B8_B7) || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_B12_B6_B8_B7)
#define CHIP_PIN_PB6_SPI1_SCK_MST       CHIP_PIN_ID_AF      (CHIP_PORT_B, 6, CHIP_PER_ID_SPI1)
#define CHIP_PIN_PB6_SPI1_SCK_SLV       CHIP_PIN_ID_IN      (CHIP_PORT_B, 6, CHIP_PER_ID_SPI1)
#endif
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B5_B7_B6_B2)
#define CHIP_PIN_PB6_LPTIM1_ETR         CHIP_PIN_ID_IN      (CHIP_PORT_B, 6, CHIP_PER_ID_LPTIM1)
#endif


/*----- Пин PB7  ------------------------------------------------------------ */
#define CHIP_PIN_PB7_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 7)
#define CHIP_PIN_PB7_CMP2_N1            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 7)
#define CHIP_PIN_PB7_USBPD_CC2_SNK      CHIP_PIN_ID_IN_EX   (CHIP_PORT_B, 7, CHIP_PER_ID_USBPD, CHIP_PIN_CFG_OSPEED_50MHZ | CHIP_PIN_CFG_NOPULL)
#define CHIP_PIN_PB7_USBPD_CC2_SRC      CHIP_PIN_ID_IN_EX   (CHIP_PORT_B, 7, CHIP_PER_ID_USBPD, CHIP_PIN_CFG_OSPEED_50MHZ | CHIP_PIN_CFG_PULLUP)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9)
#define CHIP_PIN_PB7_TIM1_CH1_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 7, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PB7_TIM1_CH1_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 7, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PB7_TIM1_CH3N          CHIP_PIN_ID_AF      (CHIP_PORT_B, 7, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM4 || (CHIP_IOREMAP_TIM4 == CHIP_IOREMAP_TIM4_B6_9)
#define CHIP_PIN_PB7_TIM4_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 7, CHIP_PER_ID_TIM4)    /* std */
#define CHIP_PIN_PB7_TIM4_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 7, CHIP_PER_ID_TIM4)    /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B6_7_A8_A11_12)
#define CHIP_PIN_PB7_USART1_RX          CHIP_PIN_ID_IN      (CHIP_PORT_B, 7, CHIP_PER_ID_USART1)  /* std */
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A5_A4_A6_B7_8) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B12_A12_B6_8)
#define CHIP_PIN_PB7_USART1_CTS         CHIP_PIN_ID_IN      (CHIP_PORT_B, 7, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_I2C1 || (CHIP_IOREMAP_I2C1 == CHIP_IOREMAP_I2C1_B6_7)
#define CHIP_PIN_PB7_I2C1_SDA           CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 7, CHIP_PER_ID_I2C1)    /* std */
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A12_B6_B8_B7) || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_B12_B6_B8_B7)
#define CHIP_PIN_PB7_SPI1_MOSI_MST      CHIP_PIN_ID_AF      (CHIP_PORT_B, 7, CHIP_PER_ID_SPI1)
#define CHIP_PIN_PB7_SPI1_MOSI_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_B, 7, CHIP_PER_ID_SPI1)
#endif
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B5_B7_B6_B2)
#define CHIP_PIN_PB7_LPTIM1_IN2         CHIP_PIN_ID_IN      (CHIP_PORT_B, 7, CHIP_PER_ID_LPTIM1)
#endif


/*----- Пин PB8  ------------------------------------------------------------ */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 28
#define CHIP_PIN_PB8_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 8)
#define CHIP_PIN_PB8_CMP2_P0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 8)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A13_B1_B8_B6_A3_A12_A14_A1_B7)
#define CHIP_PIN_PB8_TIM1_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 8, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PB8_TIM1_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 8, CHIP_PER_ID_TIM1)
#endif
#define CHIP_PIN_PB8_TIM4_CH3_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 8, CHIP_PER_ID_TIM4)  /* std */
#define CHIP_PIN_PB8_TIM4_CH3_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 8, CHIP_PER_ID_TIM4)  /* std */
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_B8_A5_A4)
#define CHIP_PIN_PB8_TIM2_CH2_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 8, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PB8_TIM2_CH2_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 8, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_A5_A4_A6_B7_8) || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B12_A12_B6_8)
#define CHIP_PIN_PB8_USART1_RTS         CHIP_PIN_ID_AF      (CHIP_PORT_B, 8, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_A12_B6_B8_B7) || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_B12_B6_B8_B7)
#define CHIP_PIN_PB8_SPI1_MISO_MST      CHIP_PIN_ID_IN      (CHIP_PORT_B, 8, CHIP_PER_ID_SPI1)
#define CHIP_PIN_PB8_SPI1_MISO_SLV      CHIP_PIN_ID_AF      (CHIP_PORT_B, 8, CHIP_PER_ID_SPI1)
#endif
#if !defined CHIP_IOREMAP_CAN1 || (CHIP_IOREMAP_CAN1 == CHIP_IOREMAP_CAN1_B8_9)
#define CHIP_PIN_PB8_CAN1_RX            CHIP_PIN_ID_IN      (CHIP_PORT_B, 8, CHIP_PER_ID_CAN1) /* std */
#endif
#endif


/*----- Пин PB9  ----------------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32
#define CHIP_PIN_PB9_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 9)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9)
#define CHIP_PIN_PB9_TIM1_CH3N          CHIP_PIN_ID_AF      (CHIP_PORT_B, 9, CHIP_PER_ID_TIM1)
#endif
#define CHIP_PIN_PB9_TIM4_CH4_IN        CHIP_PIN_ID_IN      (CHIP_PORT_B, 9, CHIP_PER_ID_TIM4)  /* std */
#define CHIP_PIN_PB9_TIM4_CH4_OUT       CHIP_PIN_ID_AF      (CHIP_PORT_B, 9, CHIP_PER_ID_TIM4)  /* std */
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B11_B9_A6_A14_A13)
#define CHIP_PIN_PB9_USART1_RX          CHIP_PIN_ID_IN      (CHIP_PORT_B, 9, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_I2C1 || (CHIP_IOREMAP_I2C1 == CHIP_IOREMAP_I2C1_B9_B11)
#define CHIP_PIN_PB9_I2C1_SCL           CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 9, CHIP_PER_ID_I2C1)
#endif
#if !defined CHIP_IOREMAP_CAN1 || (CHIP_IOREMAP_CAN1 == CHIP_IOREMAP_CAN1_B8_9)
#define CHIP_PIN_PB9_CAN1_TX            CHIP_PIN_ID_AF      (CHIP_PORT_B, 9, CHIP_PER_ID_CAN1)  /* std */
#endif
#endif


/*----- Пин PB10 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_QFN32) && (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PB10_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 10)
#define CHIP_PIN_PB10_CMP1_OUT1         CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 10)
#define CHIP_PIN_PB10_CMP3_P1           CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 10)
#define CHIP_PIN_PB10_OPA_N2            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 10)
#define CHIP_PIN_PB10_OPA_N6            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 10)
#if !defined CHIP_IOREMAP_TIM4 || (CHIP_IOREMAP_TIM4 == CHIP_IOREMAP_TIM4_B10_11_B8_9)
#define CHIP_PIN_PB10_TIM4_CH1_IN       CHIP_PIN_ID_IN      (CHIP_PORT_B, 10, CHIP_PER_ID_TIM4)
#define CHIP_PIN_PB10_TIM4_CH1_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_B, 10, CHIP_PER_ID_TIM4)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_1_B10_11) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_B10_11)
#define CHIP_PIN_PB10_TIM2_CH3_IN       CHIP_PIN_ID_IN      (CHIP_PORT_B, 10, CHIP_PER_ID_TIM2)   /* std */
#define CHIP_PIN_PB10_TIM2_CH3_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_B, 10, CHIP_PER_ID_TIM2)   /* std */
#endif
#if !defined CHIP_IOREMAP_USART3 || (CHIP_IOREMAP_USART3 == CHIP_IOREMAP_USART3_B10_14)
#define CHIP_PIN_PB10_USART3_TX         CHIP_PIN_ID_AF      (CHIP_PORT_B, 10, CHIP_PER_ID_USART3) /* std */
#endif
#define CHIP_PIN_PB10_I2C_SCL           CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 10, CHIP_PER_ID_I2C)    /* std */
#endif


/*----- Пин PB11 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_QFN32) && (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PB11_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 11)
#define CHIP_PIN_PB11_CMP2_OUT1         CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 11)
#define CHIP_PIN_PB11_CMP3_N1           CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 11)
#define CHIP_PIN_PB11_OPA_N0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 11)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_A1_A7_A14_B1_A13_B11_B0_B9) || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A3_A1_A7_A14_B1_A13_B11_B0_B9)
#define CHIP_PIN_PB11_TIM1_CH1N         CHIP_PIN_ID_AF      (CHIP_PORT_B, 11, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A0_1_B10_11) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A15_B3_B10_11)
#define CHIP_PIN_PB11_TIM2_CH4_IN       CHIP_PIN_ID_IN      (CHIP_PORT_B, 11, CHIP_PER_ID_TIM2)   /* std */
#define CHIP_PIN_PB11_TIM2_CH4_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_B, 11, CHIP_PER_ID_TIM2)   /* std */
#endif
#if !defined CHIP_IOREMAP_TIM4 || (CHIP_IOREMAP_TIM4 == CHIP_IOREMAP_TIM4_B10_11_B8_9)
#define CHIP_PIN_PB11_TIM4_CH2_IN       CHIP_PIN_ID_IN      (CHIP_PORT_B, 11, CHIP_PER_ID_TIM4)
#define CHIP_PIN_PB11_TIM4_CH2_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_B, 11, CHIP_PER_ID_TIM4)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B11_B9_A6_A14_A13)
#define CHIP_PIN_PB11_USART1_TX         CHIP_PIN_ID_AF      (CHIP_PORT_B, 11, CHIP_PER_ID_USART1)
#endif
#if !defined CHIP_IOREMAP_USART3 || (CHIP_IOREMAP_USART3 == CHIP_IOREMAP_USART3_B10_14)
#define CHIP_PIN_PB11_USART3_RX         CHIP_PIN_ID_IN      (CHIP_PORT_B, 11, CHIP_PER_ID_USART3) /* std */
#endif
#if !defined CHIP_IOREMAP_I2C1 || (CHIP_IOREMAP_I2C1 == CHIP_IOREMAP_I2C1_B9_B11)
#define CHIP_PIN_PB11_I2C1_SDA          CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 11, CHIP_PER_ID_I2C1)
#endif
#define CHIP_PIN_PB11_I2C2_SDA          CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 11, CHIP_PER_ID_I2C2)   /* std */
#endif


/*----- Пин PB12 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG == CHIP_PKG_LQFP48) || (CHIP_DEV_PKG == CHIP_PKG_QSOP28)
#define CHIP_PIN_PB12_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 12)
#define CHIP_PIN_PB12_CMP3_OUT1         CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 12)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_B6_8_B12_A2_A12_A14_B1_B9)
#define CHIP_PIN_PB12_TIM1_CH3_IN       CHIP_PIN_ID_IN      (CHIP_PORT_B, 12, CHIP_PER_ID_TIM1)
#define CHIP_PIN_PB12_TIM1_CH3_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_B, 12, CHIP_PER_ID_TIM1)
#endif
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15)
#define CHIP_PIN_PB12_TIM1_BKIN         CHIP_PIN_ID_IN      (CHIP_PORT_B, 12, CHIP_PER_ID_TIM1)  /* std */
#endif
#if !defined CHIP_IOREMAP_TIM2 || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A3_A2_B12_A6) || (CHIP_IOREMAP_TIM2 == CHIP_IOREMAP_TIM2_A12_A2_B12_A6)
#define CHIP_PIN_PB12_TIM2_CH3_IN       CHIP_PIN_ID_IN      (CHIP_PORT_B, 12, CHIP_PER_ID_TIM2)
#define CHIP_PIN_PB12_TIM2_CH3_OUT      CHIP_PIN_ID_AF      (CHIP_PORT_B, 12, CHIP_PER_ID_TIM2)
#endif
#if !defined CHIP_IOREMAP_USART1 || (CHIP_IOREMAP_USART1 == CHIP_IOREMAP_USART1_B12_A12_B6_8)
#define CHIP_PIN_PB12_USART1_TX         CHIP_PIN_ID_AF      (CHIP_PORT_B, 12, CHIP_PER_ID_USART1)
#endif
#define CHIP_PIN_PB12_USART3_CK         CHIP_PIN_ID_AF      (CHIP_PORT_B, 12, CHIP_PER_ID_USART3) /* std */
#define CHIP_PIN_PB12_I2C2_SMBA         CHIP_PIN_ID_AF_OD   (CHIP_PORT_B, 12, CHIP_PER_ID_I2C2)   /* std */
#if !defined CHIP_IOREMAP_SPI1 || (CHIP_IOREMAP_SPI1 == CHIP_IOREMAP_SPI1_B12_B6_B8_B7)
#define CHIP_PIN_PB12_SPI1_NSS_MST      CHIP_PIN_ID_AF      (CHIP_PORT_B, 12, CHIP_PER_ID_SPI1)
#define CHIP_PIN_PB12_SPI1_NSS_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_B, 12, CHIP_PER_ID_SPI1)
#endif
#define CHIP_PIN_PB12_SPI2_NSS_MST      CHIP_PIN_ID_AF      (CHIP_PORT_B, 12, CHIP_PER_ID_SPI2)   /* std */
#define CHIP_PIN_PB12_SPI2_NSS_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_B, 12, CHIP_PER_ID_SPI2)   /* std */
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B12_15)
#define CHIP_PIN_PB12_LPTIM1_IN1        CHIP_PIN_ID_IN      (CHIP_PORT_B, 12, CHIP_PER_ID_LPTIM1)
#endif
#endif


/*----- Пин PB13 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_QFN32) && (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PB13_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 13)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15)
#define CHIP_PIN_PB13_TIM1_CH1N         CHIP_PIN_ID_AF      (CHIP_PORT_B, 13, CHIP_PER_ID_TIM1)   /* std */
#endif
#define CHIP_PIN_PB13_USART3_CTS        CHIP_PIN_ID_IN      (CHIP_PORT_B, 13, CHIP_PER_ID_USART3) /* std */
#define CHIP_PIN_PB13_SPI2_SCK_MST      CHIP_PIN_ID_AF      (CHIP_PORT_B, 13, CHIP_PER_ID_SPI2)   /* std */
#define CHIP_PIN_PB13_SPI2_SCK_SLV      CHIP_PIN_ID_IN      (CHIP_PORT_B, 13, CHIP_PER_ID_SPI2)   /* std */
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B12_15)
#define CHIP_PIN_PB13_LPTIM1_IN2        CHIP_PIN_ID_IN      (CHIP_PORT_B, 13, CHIP_PER_ID_LPTIM1)
#endif
#endif


/*----- Пин PB14 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_QFN32) && (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PB14_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 14)
#define CHIP_PIN_PB14_OPA_P2            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 14)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15)
#define CHIP_PIN_PB14_TIM1_CH2N         CHIP_PIN_ID_AF      (CHIP_PORT_B, 14, CHIP_PER_ID_TIM1)   /* std */
#endif
#define CHIP_PIN_PB14_USART3_RTS        CHIP_PIN_ID_AF      (CHIP_PORT_B, 14, CHIP_PER_ID_USART3) /* std */
#define CHIP_PIN_PB14_SPI2_MISO_MST     CHIP_PIN_ID_IN      (CHIP_PORT_B, 14, CHIP_PER_ID_SPI2)   /* std */
#define CHIP_PIN_PB14_SPI2_MISO_SLV     CHIP_PIN_ID_AF      (CHIP_PORT_B, 14, CHIP_PER_ID_SPI2)   /* std */
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B12_15)
#define CHIP_PIN_PB14_LPTIM1_ETR        CHIP_PIN_ID_IN      (CHIP_PORT_B, 14, CHIP_PER_ID_LPTIM1)
#endif
#endif



/*----- Пин PB15 ------------------------------------------------------------ */
#if (CHIP_DEV_PKG != CHIP_PKG_TSSOP20)
#define CHIP_PIN_PB15_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_B, 15)
#define CHIP_PIN_PB15_OPA_P0            CHIP_PIN_ID_ANALOG  (CHIP_PORT_B, 15)
#if !defined CHIP_IOREMAP_TIM1 || (CHIP_IOREMAP_TIM1 == CHIP_IOREMAP_TIM1_A12_A8_11_B12_15)
#define CHIP_PIN_PB15_TIM1_CH3N         CHIP_PIN_ID_AF   cd   (CHIP_PORT_B, 15, CHIP_PER_ID_TIM1)   /* std */
#endif
#define CHIP_PIN_PB15_SPI2_MOSI_MST     CHIP_PIN_ID_AF      (CHIP_PORT_B, 15, CHIP_PER_ID_SPI2)   /* std */
#define CHIP_PIN_PB15_SPI2_MOSI_SLV     CHIP_PIN_ID_IN      (CHIP_PORT_B, 15, CHIP_PER_ID_SPI2)   /* std */
#if !defined CHIP_IOREMAP_LPTIM1 || (CHIP_IOREMAP_LPTIM1 == CHIP_IOREMAP_LPTIM1_B12_15)
#define CHIP_PIN_PB15_LPTIM1_OUT        CHIP_PIN_ID_AF      (CHIP_PORT_B, 15, CHIP_PER_ID_LPTIM1)
#endif
#endif


/************************************ Порт C **********************************/
/*----- Пин PC13 ------------------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 48
#define CHIP_PIN_PC13_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_C, 13)
#define CHIP_PIN_PC13_TAMPER_RTC        CHIP_PIN_ID_FORCED  (CHIP_PORT_C, 13, CHIP_PER_ID_RTC)   /* std */
#endif


/*----- Пин PC14, OSC32_IN ------------------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32
#define CHIP_PIN_PC14_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_C, 14)
#define CHIP_PIN_PC14_OSC32_IN          CHIP_PIN_ID_FORCED  (CHIP_PORT_C, 14, CHIP_PER_ID_RTC)   /* std */
#endif


/*----- Пин PC15, OSC32_OUT ----------------------------------------------------------- */
#if CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32
#define CHIP_PIN_PC15_GPIO              CHIP_PIN_ID_GPIO    (CHIP_PORT_C, 15)
#define CHIP_PIN_PC15_OSC32_OUT         CHIP_PIN_ID_FORCED  (CHIP_PORT_C, 15, CHIP_PER_ID_RTC)   /* std */
#endif


/*********************************** Порт D ***********************************/
/*----- Пин PD0, OSC_IN  ---------------------------------------------------- */
#if (CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 28) || (CHIP_DEV_PKG == CHIP_PKG_TSSOP20)
#define CHIP_PIN_PD0_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_D, 0)
#if !defined CHIP_IOREMAP_USART3 || (CHIP_IOREMAP_USART3 == CHIP_IOREMAP_USART3_D0_D1_B12_B14)
#define CHIP_PIN_PD0_USART3_TX          CHIP_PIN_ID_AF      (CHIP_PORT_D, 0, CHIP_PER_ID_USART3)
#endif
#if !defined CHIP_IOREMAP_USART3 || (CHIP_IOREMAP_USART3 == CHIP_IOREMAP_USART3_D1_D0_B12_B14)
#define CHIP_PIN_PD0_USART3_RX          CHIP_PIN_ID_IN      (CHIP_PORT_D, 0, CHIP_PER_ID_USART3)
#endif
#if !defined CHIP_IOREMAP_CAN1 || (CHIP_IOREMAP_CAN1 == CHIP_IOREMAP_CAN1_D0_1)
#define CHIP_PIN_PD0_CAN1_RX            CHIP_PIN_ID_IN      (CHIP_PORT_D, 0, CHIP_PER_ID_CAN1)  /* std */
#endif
#endif


/*----- Пин PD1, OSC_OUT ---------------------------------------------------- */
#if (CHIP_PKG_ID_PINCNT(CHIP_DEV_PKG) >= 32)  || (CHIP_DEV_PKG == CHIP_PKG_TSSOP20)
#define CHIP_PIN_PD1_GPIO               CHIP_PIN_ID_GPIO    (CHIP_PORT_D, 1)
#if !defined CHIP_IOREMAP_USART3 || (CHIP_IOREMAP_USART3 == CHIP_IOREMAP_USART3_D1_D0_B12_B14)
#define CHIP_PIN_PD1_USART3_TX          CHIP_PIN_ID_AF      (CHIP_PORT_D, 1, CHIP_PER_ID_USART3)
#endif
#if !defined CHIP_IOREMAP_USART3 || (CHIP_IOREMAP_USART3 == CHIP_IOREMAP_USART3_D0_D1_B12_B14)
#define CHIP_PIN_PD1_USART3_RX          CHIP_PIN_ID_IN      (CHIP_PORT_D, 1, CHIP_PER_ID_USART3)
#endif
#if !defined CHIP_IOREMAP_CAN1 || (CHIP_IOREMAP_CAN1 == CHIP_IOREMAP_CAN1_D0_1)
#define CHIP_PIN_PD1_CAN1_TX            CHIP_PIN_ID_AF      (CHIP_PORT_D, 1, CHIP_PER_ID_CAN1)  /* std */
#endif
#endif

#endif // CHIP_PINS_H
